"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tools_1 = require("./utils/tools");
function renderingTypes(registers) {
    function getRenderRegister(keyName, index) {
        var register_finded = null;
        registers.forEach(function (register, key) {
            var _a = key.split(tools_1.__separator__), _keyName = _a[0], i = _a[1];
            if (keyName === _keyName && index === '' && i === undefined) {
                register_finded = register;
            }
            else if (index && _keyName === keyName && i === index.toString()) {
                register_finded = register;
            }
        });
        return function () {
            if (register_finded) {
                register_finded.render();
                return true;
            }
            return false;
        };
    }
    function render(keyName, index) {
        var rendered = false;
        if (Array.isArray(keyName)) {
            for (var key in keyName) {
                rendered = getRenderRegister(key, index || '')();
            }
        }
        else {
            rendered = getRenderRegister(keyName, index || '')();
        }
        return rendered;
    }
    function renders(keyName, omits) {
        if (omits === void 0) { omits = []; }
        var count = 0;
        registers.forEach(function (register, key) {
            var _a = key.split(tools_1.__separator__), _keyName = _a[0], _index = _a[1];
            if (omits.find(function (omit) { return omit === _index; }))
                return;
            if (_keyName === keyName && _index) {
                register.render();
                count++;
            }
        });
        return count;
    }
    return {
        render: render,
        renders: renders
    };
}
exports.default = renderingTypes;
